/********************************************************************************
|  CLASS:         TLS2118T-A  X IDE & MCC & XC8 的綜合基礎課程，使用 PIC18F45K22 
|  PROGRAM:       PC101 Lab1.x 
|  AUTHOR:        Richard Yang
|  DATE:          16 May 2016
|  DESCRIPTION:   First MPLAB XC8 project to test whether everything is working
|  REQUIREMENTS:      
| 
|  REVISION HISTORY:
| 
********************************************************************************/
#include <xc.h>

// 本練習的 Configuration Bits 的基本設定
#pragma config PLLCFG = OFF, FOSC=INTIO67, BOREN = SBORDIS, BORV = 190, PWRTEN = OFF, WDTEN=OFF, PBADEN=OFF,  LVP = OFF, XINST = OFF, MCLRE = EXTMCLR

// 內部 EEPROM 的初始資料設定方式
__EEPROM_DATA(0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07);
__EEPROM_DATA(0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F);


void	SW_Delay(void)              // 軟體延遲函數，延遲 125mS @8MHz
{
	unsigned    Delay_X;
	for ( Delay_X = 0 ; Delay_X < 19230 ; Delay_X ++)
	{
            Nop( );
	}
}

void main(void)
{
	OSCCONbits.IRCF = 0x06 ;		// 調整 IRCF 位元來設定工作頻率
                                    // Select INTOSC-8Mhz as clock source
                                    // 此位元結構成員名稱，請參考 pic18f45K22.h 檔裡的名稱定義
                                    // 參考一下 Data Sheet REGISTER 2-1: OSCCON: OSCILLATOR CONTROL REGISTER
                                    // OSCCON 暫存器 bit 6-4 IRCF<2:0>: Internal RC Oscillator Frequency Select bits(2)
    
    Nop();  
    
    ANSELD = 0x00;                  // 關閉 PORTD ADC 輸入功能，設成 Digital I/O (Data Sheet: Page 153)
    TRISD = 0x00;                   // 設定 PORTD 為輸出腳功能
    LATD = 0x00 ;		            // Turn Off all LEDs
    
    while(1)
	{
		SW_Delay();                 // 延遲 125mS
		LATD++;                     // PORTD LED 遞增
	}
}
