/********************************************************************************
|  CLASS:         TLS2118T-A  X IDE & MCC & XC8 的綜合基礎課程，使用 PIC18F45K22 
|  PROGRAM:       PC101 Lab3.x 
|  AUTHOR:        Richard Yang
|  DATE:          16 May 2016
|  DESCRIPTION:   利用 Timer1 做為 125mS 的計時，使用 Polling 模式 
|  REQUIREMENTS:      
| 
|  REVISION HISTORY:
| 
********************************************************************************/
#include <xc.h>


void main(void)
{
	OSCCONbits.IRCF = 0b110 ;		// 調整 IRCF 位元來設定工作頻率
                                    // Select INTOSC-8Mhz as clock source
                                    // 此位元結構成員名稱，請參考 pic18f45K22.h 檔裡的名稱定義
                                    // 參考一下 Data Sheet REGISTER 2-1: OSCCON: OSCILLATOR CONTROL REGISTER
                                    // OSCCON 暫存器 bit 6-4 IRCF<2:0>: Internal RC Oscillator Frequency Select bits(2)
     OSCTUNE = 0x00;                // 關閉軟體 x4 PLL (PLLEN 位元) 功能
    Nop();  
    
    T1CON = 0b00110111;             //T1CKPS 1:8; T1OSCEN 關閉; T1SYNC 非同步模式; TMR1CS FOSC/4; TMR1ON 開啟; T1RD16 開啟;    
    T1GCON = 0x00;                  //T1GSS T1G; TMR1GE 關閉; T1GTM 關閉; T1GPOL low; T1GGO done; T1GSPM 關閉; 
    TMR1H = 0x85;                   //TMR1H 133，預載入 MSB (125mS)
    TMR1L = 0xEE;                   //TMR1L 238，同時載入載入 125mS 計數值到 Timer1(16-bit 載入)
    
    ANSELD = 0x00;                  // 將 PORTD ADC 輸入功能關閉，設為 Digital I/O (Data Sheet: Page 153)
    TRISD = 0x00;                   // 設定 PORTD 為輸出腳功能
    LATD = 0x00 ;		            // Turn Off all LEDs
    
    while (1)
    {
        while(!TMR1IF);        // 檢查 Timer1 250mS 計時溢位了嗎? (沒有，繼續等待)
        TMR1IF=0;              // 時間溢位，清除旗號
        TMR1H = 0x85;                   //TMR1H 133，預載入 MSB (125mS) (重新載入Timer1 120mS 的計時)
        TMR1L = 0xEE;                   //TMR1L 238，同時載入載入 125mS 計數值到 Timer1(16-bit 載入)                
        LATD++;                        // PORTD 計數 LED 加一   
    }
}
