/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - v3.00
        Device            :  PIC18F45K22
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.20

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set LCD_E aliases
#define LCD_E_TRIS               TRISA2
#define LCD_E_LAT                LATA2
#define LCD_E_PORT               RA2
#define LCD_E_ANS                ANSA2
#define LCD_E_SetHigh()    do { LATA2 = 1; } while(0)
#define LCD_E_SetLow()   do { LATA2 = 0; } while(0)
#define LCD_E_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define LCD_E_GetValue()         RA2
#define LCD_E_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define LCD_E_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define LCD_E_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define LCD_E_SetDigitalMode()   do { ANSA2 = 0; } while(0)


// get/set LCD_DATA0 aliases
#define LCD_DATA0_TRIS               TRISD0
#define LCD_DATA0_LAT                LATD0
#define LCD_DATA0_PORT               RD0
#define LCD_DATA0_ANS                ANSD0
#define LCD_DATA0_SetHigh()    do { LATD0 = 1; } while(0)
#define LCD_DATA0_SetLow()   do { LATD0 = 0; } while(0)
#define LCD_DATA0_Toggle()   do { LATD0 = ~LATD0; } while(0)
#define LCD_DATA0_GetValue()         RD0
#define LCD_DATA0_SetDigitalInput()    do { TRISD0 = 1; } while(0)
#define LCD_DATA0_SetDigitalOutput()   do { TRISD0 = 0; } while(0)

#define LCD_DATA0_SetAnalogMode()   do { ANSD0 = 1; } while(0)
#define LCD_DATA0_SetDigitalMode()   do { ANSD0 = 0; } while(0)


// get/set LCD_DATA1 aliases
#define LCD_DATA1_TRIS               TRISD1
#define LCD_DATA1_LAT                LATD1
#define LCD_DATA1_PORT               RD1
#define LCD_DATA1_ANS                ANSD1
#define LCD_DATA1_SetHigh()    do { LATD1 = 1; } while(0)
#define LCD_DATA1_SetLow()   do { LATD1 = 0; } while(0)
#define LCD_DATA1_Toggle()   do { LATD1 = ~LATD1; } while(0)
#define LCD_DATA1_GetValue()         RD1
#define LCD_DATA1_SetDigitalInput()    do { TRISD1 = 1; } while(0)
#define LCD_DATA1_SetDigitalOutput()   do { TRISD1 = 0; } while(0)

#define LCD_DATA1_SetAnalogMode()   do { ANSD1 = 1; } while(0)
#define LCD_DATA1_SetDigitalMode()   do { ANSD1 = 0; } while(0)


// get/set LCD_DATA2 aliases
#define LCD_DATA2_TRIS               TRISD2
#define LCD_DATA2_LAT                LATD2
#define LCD_DATA2_PORT               RD2
#define LCD_DATA2_ANS                ANSD2
#define LCD_DATA2_SetHigh()    do { LATD2 = 1; } while(0)
#define LCD_DATA2_SetLow()   do { LATD2 = 0; } while(0)
#define LCD_DATA2_Toggle()   do { LATD2 = ~LATD2; } while(0)
#define LCD_DATA2_GetValue()         RD2
#define LCD_DATA2_SetDigitalInput()    do { TRISD2 = 1; } while(0)
#define LCD_DATA2_SetDigitalOutput()   do { TRISD2 = 0; } while(0)

#define LCD_DATA2_SetAnalogMode()   do { ANSD2 = 1; } while(0)
#define LCD_DATA2_SetDigitalMode()   do { ANSD2 = 0; } while(0)


// get/set LCD_DATA3 aliases
#define LCD_DATA3_TRIS               TRISD3
#define LCD_DATA3_LAT                LATD3
#define LCD_DATA3_PORT               RD3
#define LCD_DATA3_ANS                ANSD3
#define LCD_DATA3_SetHigh()    do { LATD3 = 1; } while(0)
#define LCD_DATA3_SetLow()   do { LATD3 = 0; } while(0)
#define LCD_DATA3_Toggle()   do { LATD3 = ~LATD3; } while(0)
#define LCD_DATA3_GetValue()         RD3
#define LCD_DATA3_SetDigitalInput()    do { TRISD3 = 1; } while(0)
#define LCD_DATA3_SetDigitalOutput()   do { TRISD3 = 0; } while(0)

#define LCD_DATA3_SetAnalogMode()   do { ANSD3 = 1; } while(0)
#define LCD_DATA3_SetDigitalMode()   do { ANSD3 = 0; } while(0)


// get/set LCD_RS aliases
#define LCD_RS_TRIS               TRISD4
#define LCD_RS_LAT                LATD4
#define LCD_RS_PORT               RD4
#define LCD_RS_ANS                ANSD4
#define LCD_RS_SetHigh()    do { LATD4 = 1; } while(0)
#define LCD_RS_SetLow()   do { LATD4 = 0; } while(0)
#define LCD_RS_Toggle()   do { LATD4 = ~LATD4; } while(0)
#define LCD_RS_GetValue()         RD4
#define LCD_RS_SetDigitalInput()    do { TRISD4 = 1; } while(0)
#define LCD_RS_SetDigitalOutput()   do { TRISD4 = 0; } while(0)

#define LCD_RS_SetAnalogMode()   do { ANSD4 = 1; } while(0)
#define LCD_RS_SetDigitalMode()   do { ANSD4 = 0; } while(0)


// get/set LCD_RW aliases
#define LCD_RW_TRIS               TRISD5
#define LCD_RW_LAT                LATD5
#define LCD_RW_PORT               RD5
#define LCD_RW_ANS                ANSD5
#define LCD_RW_SetHigh()    do { LATD5 = 1; } while(0)
#define LCD_RW_SetLow()   do { LATD5 = 0; } while(0)
#define LCD_RW_Toggle()   do { LATD5 = ~LATD5; } while(0)
#define LCD_RW_GetValue()         RD5
#define LCD_RW_SetDigitalInput()    do { TRISD5 = 1; } while(0)
#define LCD_RW_SetDigitalOutput()   do { TRISD5 = 0; } while(0)

#define LCD_RW_SetAnalogMode()   do { ANSD5 = 1; } while(0)
#define LCD_RW_SetDigitalMode()   do { ANSD5 = 0; } while(0)


// get/set IO_RD6 aliases
#define IO_RD6_TRIS               TRISD6
#define IO_RD6_LAT                LATD6
#define IO_RD6_PORT               RD6
#define IO_RD6_ANS                ANSD6
#define IO_RD6_SetHigh()    do { LATD6 = 1; } while(0)
#define IO_RD6_SetLow()   do { LATD6 = 0; } while(0)
#define IO_RD6_Toggle()   do { LATD6 = ~LATD6; } while(0)
#define IO_RD6_GetValue()         RD6
#define IO_RD6_SetDigitalInput()    do { TRISD6 = 1; } while(0)
#define IO_RD6_SetDigitalOutput()   do { TRISD6 = 0; } while(0)

#define IO_RD6_SetAnalogMode()   do { ANSD6 = 1; } while(0)
#define IO_RD6_SetDigitalMode()   do { ANSD6 = 0; } while(0)


// get/set IO_RD7 aliases
#define IO_RD7_TRIS               TRISD7
#define IO_RD7_LAT                LATD7
#define IO_RD7_PORT               RD7
#define IO_RD7_ANS                ANSD7
#define IO_RD7_SetHigh()    do { LATD7 = 1; } while(0)
#define IO_RD7_SetLow()   do { LATD7 = 0; } while(0)
#define IO_RD7_Toggle()   do { LATD7 = ~LATD7; } while(0)
#define IO_RD7_GetValue()         RD7
#define IO_RD7_SetDigitalInput()    do { TRISD7 = 1; } while(0)
#define IO_RD7_SetDigitalOutput()   do { TRISD7 = 0; } while(0)

#define IO_RD7_SetAnalogMode()   do { ANSD7 = 1; } while(0)
#define IO_RD7_SetDigitalMode()   do { ANSD7 = 0; } while(0)



/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
*/